(in-package :user)

;;; Homework set 2-1
;;; Exercise #3: Functions

;;; 3A] Write a function expensive that calculates
;;;      the square of a number.
(defun expensive (x)
  (* x x))

;;; 3B] Write a function frugal that returns the 
;;;      same answer, but only calls expensive 
;;;      when the given arguement has not been seen
;;;      before.

;;; Define a (global) hashtable to stash previously
;;; calculated values.
(defvar *frugal-hashtable* (make-hash-table))

(defun frugal (x)
  ;; First, see if we've calculate the value before
  (let ((result (gethash x *frugal-hashtable*)))

    (when (null result)
      ;; No previously calculated value.
      ;; we need to make one...
      (setq result (expensive x))
      ;; ... and store it away.
      (setf (gethash x *frugal-hashtable*) result))
    
    ;; Finally, return the result
    result))



;;; A variant of the above that uses a lexically-bound
;;; hashtable, visible only inside the function.
(let ((*frugal-hashtable-2* (make-hash-table)))
  (defun frugal-2 (x)
    ;; First, see if we've calculate the value before
    (let ((result (gethash x *frugal-hashtable-2*)))

      (when (null result)
	  ;; No previously calculated value.
	  ;; we need to make one...
	  (setq result (expensive x))
	  ;; ... and store it away.
	  (setf (gethash x *frugal-hashtable-2*) result))
    
      ;; Finally, return the result
      result))
  )

