(in-package :user)

;;; Homework set 2-1
;;; Exercise #6: Hash Tables

;;; 6A] Using a hash table, write the following:
;;;    - (occurences '(a b r a ca d a b r a))
;;;    - Returns ((a . 4) (r . 2) (b . 2) (d . 1) (ca . 1))

;;; First, write a helper-function.
;;; Return the contents of a hash-table as a list of dotted-pairs.
(defun pairify-hash-table (htable)
  (let ((result nil))
    (maphash #'(lambda (x y) (push (cons x y) result))
	     htable)
    result))

;;; Second, write a helper-function that
;;; fills the hash-table from the list.
(defun fill-hash-table (htable list)
  (dolist (x list)
    ;; First, see if the value is already in the hash-table
    ;; NOTE:  We check the found-p value, rather than simply
    ;;        checking the returned value.
    ;;        This allows us to handle the case of a nil
    ;;        in the original list.
    (multiple-value-bind (count found-p)
	(gethash x htable)
      (cond (found-p
	       ;; The value is in the hash-table.
	       ;; So we increment it...
	       (setq count (+ count 1))
	       ;; ...and put it back in the hastable 
	       (setf (gethash x htable) count))
	      (t
	       ;; The value was not found, 
	       ;; So we insert a new value.
	       (setf (gethash x htable) 1))))))

;;; Finally, put everything together.
(defun occurences (list)
  ;; First, get a hash-table...
  (let ((htable (make-hash-table)))
    
    ;; ... then fill it with the values ...
    (fill-hash-table htable list)
    
    ;; ... then extract the dotted-pairs.
    (pairify-hash-table htable)))
    
