(in-package :user)

;;; Homework set 2-1
;;; Exercise #8: Macro Lab 2

;;; 8A]Implement rotatef as a macro
;;;  - (let ((a 1) (b 2) (rotatef a b) a) ==> 2
(defmacro myrotatef (sym1 sym2)
  `(let ((val1 (eval ,sym1))
	   (val2 (eval ,sym2)))
     (setf ,sym1 val2)
     (setf ,sym2 val1)))


;;; 8B] Implement "mydefun" as a macro that works like defun
(defmacro mydefun (function-name arglist &body body)
  `(setf (symbol-function ',function-name #'(lambda ,arglist ,@body))))


;;; 8C] Implement "mytypecase" as a macro that works like
;;;     typecase (hint: use typep and cond)
;;;    - (mytypecase x
;;;        (symbol (print 'symbol))
;;;        (string (print 'string)))

;;; First, define a helper function.
;;; Make a single cond-clause.
;;; For example:
;;;   (make-clause-1 'x '(symbol (print 'symbol)))
;;;   --> ((typep x symbol) (print 'symbol))
(defun make-clause-1 (symbol clause-data-1)
  (cons `(typep ,symbol ',(car clause-data-1))
	(cdr clause-data-1)))

;;; Turn a list of clause-data elements, 
;;; into a list of clauses
;;; For example:
;;;    (make-clauses 'x '((symbol (print 'symbol)) (string (print 'string))))
;;;    --> (((typep x symbol) (print 'symbol)) ((typep x string) (print 'string)))
(defun make-clauses (symbol clause-data-list)
  (mapcar #'(lambda (clause-data-1) 
	      (make-clause-1 symbol clause-data-1))
	  clause-data-list))

(defmacro mytypecase (symb &rest clause-data-list)
  `(cond ,@(make-clauses symb `,clause-data-list)))


